
using System;
using System.Collections.Generic;
using System.Linq;
using MonoTouch.Foundation;
using MonoTouch.UIKit;

namespace Torch
{
	public class Application
	{
		static void Main (string[] args)
		{
			UIApplication.Main (args);
		}
	}

	// The name AppDelegate is referenced in the MainWindow.xib file.
	public partial class AppDelegate : UIApplicationDelegate
	{
		private void InfoAlert (string title, string message, EventHandler<UIButtonEventArgs> callback)
		{
			using (UIAlertView av = new UIAlertView (title, message, null, "OK")) {
				av.Dismissed += callback;
				av.Show ();
			}
		}
		
		private void ConfirmAlert (string title, string message, EventHandler<UIButtonEventArgs> callback)
		{
			using (UIAlertView av = new UIAlertView (title, message, null, "No", "Yes"))
			{
				av.Clicked += callback;
				av.Show ();
			}
		}
		
		TorchController torchController;
		
		private void TorchLaunch (object sender, UIButtonEventArgs e)
		{
			if (torchController == null)
				torchController = new TorchController ();
			window.AddSubview (torchController.View);
		}
		
		void TorchLaunchConfirm (object sender, UIButtonEventArgs e)
		{
			if (e.ButtonIndex == 1)
				InfoAlert ("Information", "Torch is being turned on...", TorchLaunch);
		}
		
		// This method is invoked when the application has loaded its UI and its ready to run
		public override bool FinishedLaunching (UIApplication app, NSDictionary options)
		{
			torchButton.TouchUpInside += delegate {
				ConfirmAlert ("Confirmation", "Are you sure you want\nto turn on the torch?", TorchLaunchConfirm);
			};
			
			window.MakeKeyAndVisible ();			
			return true;
		}

		// This method is required in iPhoneOS 3.0
		public override void OnActivated (UIApplication application)
		{
		}
	}
}

